//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;

public class CEditPrjB extends Dialog implements ActionListener
{
  //Variables
  CGlobal g=null;

  Dimension size;

  List lst=null;

  Button bt2=null;
  String str2="Edit file";

  Button bt3=null;
  String str3="Ok";

  String prj_name="";

  Frame Parent=null;

  CProject cp=null;

  int mode=1;

  // *******************************************************************
  public CEditPrjB(Frame dw, CGlobal glob, CProject cp1, 
                             String prj_name1, int mode1)
  {
    super(dw, "Edit prj_b", true);
 
    g=glob;

    Parent=dw;

    int gap=3;

    cp=cp1;

    prj_name=prj_name1;

    mode=mode1;

    Panel p1a=new Panel();
    BorderLayout lt1a=new BorderLayout();
    lt1a.setHgap(gap);
    lt1a.setVgap(gap);
    p1a.setLayout(lt1a);

    Panel p1b=new Panel();
    lst = new List(15, false);
    lst.add("______________________________________________________________________________");

    p1b.add(lst);

    Panel p1c1=new Panel();
    bt2=new Button(str2);
    bt2.addActionListener(this);
    p1c1.add(bt2);

    Panel p1c2=new Panel();
    bt3=new Button(str3);
    bt3.addActionListener(this);
    p1c2.add(bt3);

    Panel p1c=new Panel();
    BorderLayout lt1c=new BorderLayout();
    lt1c.setHgap(gap);
    lt1c.setVgap(gap);
    p1c.setLayout(lt1c);

    p1c.add(p1c1, "North");
    p1c.add(p1c2, "South");

    //First panel for border
    BorderLayout lt1=new BorderLayout();
    lt1.setHgap(gap);
    lt1.setVgap(gap);
    Panel p1=new Panel();
    p1.setLayout(lt1);

    p1.add(p1a, "North");
    p1.add(p1b, "Center");
    p1.add(p1c, "South");

    add(p1);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    //Packing elements in window
    pack();

    update_list();

    size=getSize();
		
    //Initializing parameters
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
                 AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String cm = e.getActionCommand();

    if (cm.equals(str2)) 
    {	        
      int i=lst.getSelectedIndex()+1;

      CEditPrjB_File epbf=new CEditPrjB_File(Parent, g, i, cp, prj_name, mode);
      epbf=null;

      if (cp.Parse()<0)
      {
        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, cp.GetLastError());
        mb=null;

        System.gc();
        System.runFinalization();

        return;
      }

      update_list();

      System.gc();
      System.runFinalization();
    } 
    else if (cm.equals(str3)) 
    {	        
      System.gc();
      System.runFinalization();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      dispose();
    }
  }

  // *******************************************************************
  public void update_list()
  {
    lst.removeAll();

    for (int i=1; i<cp.GetNumFiles(); i++)
    {
      lst.add(cp.GetLngNameOrig(i)+", "+
              cp.GetFileName(i)+
              cp.GetFileExt(i));

    }
  }
}
