//
// Class CMsgBox
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;

public class CMsgBox extends Dialog implements ActionListener
{
  //Variables
  Dimension size;

  Label comp1;

  Button comp2a;
  Button comp2b;
  Button comp2c;

  String str2a="OK";
  String str2b="Yes";
  String str2c="No";
  
  int ret;
  
  // *******************************************************************
  //type = 0 - Ask question: Yes/No
  //       1 - Warning: Ok
  public CMsgBox(Frame dw, int type, String msg)
  {
    super(dw, "Message Box", true);

    ret=0;

    int gap=10;

    //First panel for border
    Panel p=new Panel();
    FlowLayout lt=new FlowLayout(FlowLayout.LEFT);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);

    add(p);

    BorderLayout lt0=new BorderLayout();
    lt0.setHgap(gap);
    lt0.setVgap(gap);

    FlowLayout lt1=new FlowLayout(FlowLayout.CENTER);
    lt1.setHgap(gap);
    lt1.setVgap(gap);

    FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

    CFramedArea p1=new CFramedArea();
    p1.setLayout(lt1);

    Panel p2=new Panel();
    p2.setLayout(lt2);

    //Creating components...
    comp1=new Label(msg);
    p1.add(comp1);

    if (type==0)
    {
      comp2b=new Button(str2b);
      comp2b.addActionListener(this);
      comp2c=new Button(str2c);
      comp2c.addActionListener(this);

      p2.add(comp2b);
      p2.add(comp2c);			
    }
    else
    {
      comp2a=new Button(str2a);
      comp2a.addActionListener(this);

      p2.add(comp2a);
    }

    p.setLayout(lt0);
    p.add("Center", p1);
    p.add("South", p2);		

    //Positioning
//    Point pt=dw.getLocationOnScreen();

//    setLocation(pt.x+80, pt.y+80);

    //Packing elements in window
    pack();

    size=getSize();

    setResizable(false);

    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
    AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String x;

    String command = e.getActionCommand();
    if (command.equals(str2a)) 
    {	        
      ret=1;
      dispose();
    } 
    else if (command.equals(str2b))
    {           
      ret=1;
      dispose();
    } 
    else if (command.equals(str2c)) 
    {
      ret=2;
      dispose();
    } 
  }

  //*******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      ret=0;
      dispose();
    }
  }

  // ************************
  public int getRet()
  {
    return ret;	
  }
}
