//
// "Edinburgh Optimizing Software" Client
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;
import java.awt.*;

//Main class
public class client
{
  // *******************************************************************
  public static void main(String args[]) 
  {
    long misc;
    String FileCFG="client.cfg";
    
    //***********************************************************************
    System.out.println("EOS Client   V2.2   (C) by Grigori G.Fursin   June,2004");

    //Declaration of class with global variables
    CGlobal glob = new CGlobal();

    //Declaration of class for configuration file parsing
    glob.cfg = new CConfig();

    if (glob.cfg.Init(40, 0, FileCFG, 40)!=0)
    //                 |  |        |   |
    //                 |  |        |   |--- Max Number of Array Parameters
    //                 |  |        | 
    //                 |  |        |-------- Name of File with Parameters
    //                 |  |
    //                 |  |----------------- 1 - Ignore case, 0 - Don't ignore case (for value)
    //                 |
    //                 |-------------------- Max Number of Parameters
    {
      System.out.println("\nError: Can't initialize object CConfig!");
      return;
    }

    misc=0;
  
    misc+=glob.cfg.Add("show_window_about",      "",  1);  //Param  0
    misc+=glob.cfg.Add("save_position_and_size", "",  1);  //Param  1
    misc+=glob.cfg.Add("x",                      "",  1);  //Param  2
    misc+=glob.cfg.Add("y" ,                     "",  1);  //Param  3
    misc+=glob.cfg.Add("xl",                     "",  1);  //Param  4
    misc+=glob.cfg.Add("yl",                     "",  1);  //Param  5
    misc+=glob.cfg.Add("separator",              "",  1);  //Param  6
    misc+=glob.cfg.Add("platforms",              "",  1);  //Param  7
    misc+=glob.cfg.Add("path_local",             "",  1);  //Param  8
    misc+=glob.cfg.Add("platform",               "",  1);  //Param  9
    misc+=glob.cfg.Add("ac_server_port",         "",  1);  //Param 10
    misc+=glob.cfg.Add("mpc_server_port",        "",  1);  //Param 11
    misc+=glob.cfg.Add("time_precision_steps",   "",  1);  //Param 12
    misc+=glob.cfg.Add("path_local1",            "",  1);  //Param 13
    misc+=glob.cfg.Add("optimization",           "",  1);  //Param 14
    misc+=glob.cfg.Add("dependency",             "",  1);  //Param 15
    misc+=glob.cfg.Add("loop",                   "",  1);  //Param 16
    misc+=glob.cfg.Add("pass",                   "",  1);  //Param 17
    misc+=glob.cfg.Add("s_server_port",          "",  1);  //Param 18
    misc+=glob.cfg.Add("optimization1",          "",  1);  //Param 19
    misc+=glob.cfg.Add("search",                 "",  1);  //Param 20
    misc+=glob.cfg.Add("pad",                    "",  1);  //Param 21
    misc+=glob.cfg.Add("tile",                   "",  1);  //Param 22
    misc+=glob.cfg.Add("unroll",                 "",  1);  //Param 23
    misc+=glob.cfg.Add("grid",                   "",  1);  //Param 24
    misc+=glob.cfg.Add("random",                 "",  1);  //Param 25
    misc+=glob.cfg.Add("sfb",                    "",  1);  //Param 26
    misc+=glob.cfg.Add("apo",                    "",  1);  //Param 27
    misc+=glob.cfg.Add("step",                   "",  1);  //Param 28
    misc+=glob.cfg.Add("io",                     "",  1);  //Param 29
    misc+=glob.cfg.Add("rt",                     "",  1);  //Param 30
    misc+=glob.cfg.Add("cd",                     "",  1);  //Param 31
    misc+=glob.cfg.Add("ri",                     "",  1);  //Param 32
    misc+=glob.cfg.Add("noe",                    "",  1);  //Param 33

    if (misc!=0)
    {
      System.out.println("\nError: Internal, while initializing CConfig!");
      return;
    }

    misc=glob.cfg.Parse();
    if (misc==1)
    {
      System.out.println("\nError: Can't find configuration file!");
      return;
    }
    else if (misc==2)
    {
      System.out.println("\nError: Unknown syntax in configration file!");
      return;
    }
    else if (misc==3)
    {
      System.out.println("\nError: Unknown syntax in configration file!");
      return;
    }
    else if (misc==4)
    {
      System.out.println("\nError: Unknown parameter in configuration file!");
      return;
    }
    else if (misc==5)
    {
      System.out.println("\nError: IO Problems while parsing configuration file!");
      return;
    }
    else if (misc>0)
    {
      System.out.println("\nError: Internal, while parsing configuration file!");
      return;
    }

    //Prepare Platforms
    glob.plt=new CPlatforms();

    if (glob.plt.Init(glob.platMax, "client_platform", ".cfg")!=0)
    {
      System.out.println("\nError: Can't initialize object CPlatforms!");
      return;
    }

    if (glob.plt.Parse(glob.cfg.GetParamInt(glob.cfgPlat))!=0)
    {
      System.out.println("\nError: Can't parse platform configuration files!");
      return;
    }

    //Prepare Triggers
    glob.tg=new CTrig(32);

    //Prepare main frame
    CFrameMain fm=new CFrameMain(glob);

    //Set Background color for all windows...
    fm.setBackground(SystemColor.menu);
    //fm.setBackground(Color.lightGray);

    if (glob.cfg.GetParamInt(glob.cfgSWA)==1)
    {
      CAbout frame_about=new CAbout(fm, glob, 1);
      while (!glob.tg.trig[1]) 
      {
        try
        {
          Thread.sleep(500);
        }
        catch (InterruptedException e) {}
      }

      frame_about=null;

      System.gc();
      System.runFinalization();
    }

    fm.Init();
    fm.show();
  }
}
