/*--------------------------------------------------------------------+
 | OCTAVE - Optimising Compiler Tool And Visualisation Environment    |
 |                                                                    |
 | Copyright (C) University of Edinburgh, 1993.                       |
 |                                                                    |
 | OCTAVE is free software; you can redistribute it and/or modify     |
 | it under the terms of the GNU General Public License as published  |
 | by the Free Software Foundation; either version 1, or (at your     |
 | option) any later version.                                         |
 |                                                                    |
 | OCTAVE is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of     |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
 | GNU General Public License for more details.                       |
 |                                                                    |
 | You should have received a copy of the GNU General Public License  |
 | along with OCTAVE; see the file COPYING.  If not, write to         |
 | the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,   |
 | USA.                                                               |
 +--------------------------------------------------------------------*/

// Header for character String class.

#if ! defined _strings_h_
#define _strings_h_

#include <string.h>
#include <iostream.h>

class string {
  struct srep {
    char* s ;    // pointer to actual string
    int   n ;    // reference count
  } ;
  srep *p ;

public:

  char* index () { return p->s ; }
  int variant () { return 0 ; }

  string (char *) ;  // string x = c ;
  string (const char *) ;  // string x = "abc" ;
  string () ;        // string x ;
  string (string&) ; // string x = string ...
  string (string*) ; // string x = pointer to string ...
  string& operator= (char *) ;
  string& operator= (const char *) ;
  string& operator= (string &) ;
  string& operator= (string *) ;
  ~string() ;
  char& operator[] (int i) ;
  char* operator() () { return p ? p->s : 0 ; }
  
  friend ostream& operator<< (ostream&, string&) ;
  friend istream& operator>> (istream&, string&) ;
  friend int operator== (string &x, const char *s) ;
  friend int operator== (string &x, string &y) ;
  friend int operator!= (string &x, const char *s) ;
  friend int operator!= (string &x, string &y) ;

} ;

#endif // _strings_h_
