//
// eos_cled 
// convert loops with labels into do/enddo format
// for fortran 77 programs
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

//Main class
public class eos_cled
{
  //**************************************************************************
  public static void main(String args[])
  {
    String str="";
    int i=0;
    int j=0; //current line

    //Logo
    System.out.println("EOS Convert loops with labels (f77)  (C) by Grigori G.Fursin   June,2004");

    if (args.length!=2)
    {
      System.out.println("                                     ");
      System.out.println("Usage:                               ");
      System.out.println(" java cled <input.file> <output.file>");
      System.exit(0);
    }

    //**********************
    System.out.println("");
    System.out.println("Pass1:");

    int imax=0;
    int jmax=0;
    j=0;

    String fn1=args[0];
    String fn2=args[1];

    BufferedReader fin=null;

    try
    {
      fin=new BufferedReader(new FileReader(fn1));
    }
    catch (IOException e2)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't open file!");
      System.exit(1);
    }

    try
    {
      while ((str=fin.readLine())!=null)
      {
        j++;
        str=tab2space_f77(str);
        String str1=str.trim();
        if (str.length()>1 && !str.substring(0,1).equals("C"))
        {
          int i1=str.toLowerCase().indexOf(" program ");
          int i2=str.toLowerCase().indexOf(" subroutine ");
          int i3=str.toLowerCase().indexOf(" function ");

          if ((i1>0) || (i2>0) || (i3>0))
          {
            imax++;
            jmax++;
          }
        }

        if (str.length()>4 && 
            !str.substring(0,1).equals("C") &&
            str.toLowerCase().indexOf(" do ")>0)
        {
          int il=str1.length();

          String str2=str1.substring(3,il).trim();

          int il1=str2.length();

          if (Character.isDigit(str2.charAt(0)))
          {
            imax++;
          }
        }
      }
    }
    catch (Exception e3)
    {
      try
      {
        fin.close();
      }
      catch (Exception e4)
      {}
      System.out.println("");
      System.out.println("Fatal Error: Problems with file!");
      System.exit(1);
    }

    try
    {
      fin.close();
    }
    catch (Exception e5)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't close file!");
      System.exit(1);
    }

    System.out.println("Number of subroutines      : "+String.valueOf(jmax));
    System.out.println("Number of loops with labels: "+String.valueOf(imax));

    //**********************
    System.out.println("");
    System.out.println("Pass2:");

    String[] LabelName=new String [imax];
    int[]    LabelNest=new int [imax];
    int[]    LabelLine=new int [imax];

    int iq=0;
    int iq1=0;
    j=0;

    try
    {
      fin=new BufferedReader(new FileReader(fn1));
    }
    catch (IOException e2)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't open file!");
      System.exit(1);
    }

    try
    {
      while ((str=fin.readLine())!=null)
      {
        j++;
        str=tab2space_f77(str);
        String str1=str.trim();

        if (str.length()>1 && !str.substring(0,1).equals("C"))
        {
          int i1=str.toLowerCase().indexOf(" program ");
          int i2=str.toLowerCase().indexOf(" subroutine ");
          int i3=str.toLowerCase().indexOf(" function ");

          if ((i1>0) || (i2>0) || (i3>0))
          {
            iq1=iq;
            LabelName[iq]="***";
            LabelNest[iq]=0;
            LabelLine[iq]=j;
            iq++;
          }
        }

        if (str.length()>4 && 
            !str.substring(0,1).equals("C") &&
            str.toLowerCase().indexOf(" do ")>0)
        {
System.out.println("xxx1");


          int il=str1.length();
          int i1=str.toLowerCase().indexOf("do ");

          String str2=str.substring(i1+3,str.length()).trim();

          int il1=str2.length();

System.out.println(str);
System.out.println("xxx2");
System.out.println(il1);


          if (Character.isDigit(str2.charAt(0)))
          {
System.out.println("xxx2a");
            for (i=0; i<il1; i++)
            {
              if (!Character.isDigit(str2.charAt(i))) break;
            }

            int i5=i;

            String str3=str2.substring(0,i5);

            boolean found=false;
            for (i=iq1; i<imax; i++)
            {
              if (str3.equals(LabelName[i]))
              {
                found=true;
                break;
              }
            }

System.out.println("xxx3");


            if (found)
            {
              LabelNest[i]++;
            }
            else
            {
              LabelName[iq]=str3;
              LabelNest[iq]=0;
              LabelLine[iq]=j;
              iq++;
            }

System.out.println("xxx4");

          }
        }
      }
    }
    catch (Exception e3)
    {
      try
      {
        fin.close();
      }
      catch (Exception e4)
      {}
      System.out.println("");
      System.out.println("Fatal Error: Problems with file!");
      System.exit(1);
    }

    try
    {
      fin.close();
    }
    catch (Exception e5)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't close file!");
      System.exit(1);
    }

    int imax5=iq;

    System.out.println("Number of loops with unique labels: "+String.valueOf(iq));

    //**********************
    System.out.println("");
    System.out.println("Pass3");

    iq=0;
    iq1=0;
    int iq2=1;
    j=0;

    try
    {
      fin=new BufferedReader(new FileReader(fn1));
    }
    catch (IOException e2)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't open file!");
      System.exit(1);
    }

    try
    {
      while ((str=fin.readLine())!=null)
      {
        str=tab2space_f77(str);

        if (str.length()>1 && !str.substring(0,1).equals("C"))
        {
          int i1=str.toLowerCase().indexOf(" program ");
          int i2=str.toLowerCase().indexOf(" subroutine ");
          int i3=str.toLowerCase().indexOf(" function ");

          if ((i1>0) || (i2>0) || (i3>0))
          {
            iq1=iq2;

            for (; iq2<imax5; iq2++)
            {
              if (LabelName[iq2].equals("***"))
              {
                break;
              }
            }
            iq2++;
            if (iq2>imax5) iq2=imax5;
          }
        }

        if (str.length()>1 && !str.substring(0,1).equals("C"))
        {
          String str1=str.trim();
          int i1=str.toLowerCase().indexOf(" goto ");
          if (i1>0)
          {
            i1=str1.toLowerCase().indexOf("goto ");
            String str2=str1.substring(i1+5, str1.length()).trim();

            if (Character.isDigit(str2.charAt(0)))
            {
              for (i=0; i<str2.length(); i++)
              {
                if (!Character.isDigit(str2.charAt(i))) break;
              }

              int i5=i;

              String str3=str2.substring(0,i5);

              boolean found=false;
              for (i=iq1; i<iq2; i++)
              {
                if (str3.equals(LabelName[i]))
                {
                  found=true;
                  break;
                }
              }

              if (found)
              {
                iq++;
                LabelName[i]="";
                LabelNest[i]=0;
              }
            }
          }
        }
      }
    }
    catch (Exception e3)
    {
      try
      {
        fin.close();
      }
      catch (Exception e4)
      {}
      System.out.println("");
      System.out.println("Fatal Error: Problems with file!");
      System.exit(1);
    }

    try
    {
      fin.close();
    }
    catch (Exception e5)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't close file!");
      System.exit(1);
    }

    System.out.println("Number of labels referred to by GOTO: "+String.valueOf(iq));

    //**********************
    System.out.println("");
    System.out.println("Pass4");

    BufferedWriter fout=null;

    iq1=0;
    iq2=1;

    try
    {
      fin=new BufferedReader(new FileReader(fn1));
      fout=new BufferedWriter(new FileWriter(fn2));
    }
    catch (IOException e2)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't open file(s)!");
      System.exit(1);
    }

    try
    {
      while ((str=fin.readLine())!=null)
      {
        str=tab2space_f77(str);
        String str1=str.trim();

        if (str.length()>1 && !str.substring(0,1).equals("C"))
        {
          int i1=str.toLowerCase().indexOf(" program ");
          int i2=str.toLowerCase().indexOf(" subroutine ");
          int i3=str.toLowerCase().indexOf(" function ");

          if ((i1>0) || (i2>0) || (i3>0))
          {
            iq1=iq2;

            for (; iq2<imax5; iq2++)
            {
              if (LabelName[iq2].equals("***"))
              {
                break;
              }
            }
            iq2++;
            if (iq2>imax5) iq2=imax5;
          }
        }

        if (str.length()>4 && 
            !str.substring(0,1).equals("C") &&
            str.toLowerCase().indexOf(" do ")>0)
        {
          if (Character.isDigit(str1.charAt(0)))
          {
            for (i=0; i<str1.length(); i++)
            {
              if (!Character.isDigit(str1.charAt(i))) break;
            }

            fout.write(str1.substring(0,i)+"       CONTINUE");
            fout.newLine();
          }

          int il=str1.length();
          int i1=str.toLowerCase().indexOf("do ");

          String str2=str.substring(i1+3,str.length()).trim();

          int il1=str2.length();

          if (Character.isDigit(str2.charAt(0)))
          {
            for (i=0; i<il1; i++)
            {
              if (!Character.isDigit(str2.charAt(i))) break;
            }

            int i5=i;

            String str3=str2.substring(0,i5);

            boolean found=false;
            for (i=iq1; i<iq2; i++)
            {
              if (str3.equals(LabelName[i]))
              {
                found=true;
                break;
              }
            }

            if (found)
            {
              str="      DO "+str2.substring(i5, il1).trim();
            }
          }
        }
        else if (str1.length()>1 && Character.isDigit(str1.charAt(0)))
        {
          int il=str1.length();

          for (i=0; i<il; i++)
          {
            if (!Character.isDigit(str1.charAt(i))) break;
          }

          String str2=str1.substring(0,i);
          String str3=str1.substring(i,il).trim();

          boolean found=false;

          for (i=iq1; i<iq2; i++)
          {
            if (str2.equals(LabelName[i]))
            {
              found=true;
              break;
            }
          }

          if (found)
          {
            if (str3.toLowerCase().equals("continue"))
            {
              str="      END DO";
              for (int i1=0; i1<LabelNest[i]; i1++)
              {
                fout.write(str);
                fout.newLine();
              }
              LabelName[i]="";
              LabelNest[i]=0;
            }
            else
            {
              str="      "+str3;
              fout.write(str);
              fout.newLine();

              boolean finish=false;
              while ((str=fin.readLine())!=null && !finish)
              {
                str=tab2space_f77(str);

                if (str.length()>5 && str.substring(5,6).equals(">"))
                {
                  fout.write(str);
                  fout.newLine();
                }
                else finish=true;
              }

              for (int i1=0; i1<=LabelNest[i]; i1++)
              {
                fout.write("      END DO");
                fout.newLine();
              }
              LabelName[i]="";
              LabelNest[i]=0;
            }
          }
        }

        fout.write(str);
        fout.newLine();
      }
    }
    catch (Exception e3)
    {
      try
      {
        fin.close();
        fout.close();
      }
      catch (Exception e4)
      {}
      System.out.println("");
      System.out.println("Fatal Error: Problems with file(s)!");
      System.exit(1);
    }

    try
    {
      fin.close();
      fout.close();
    }
    catch (Exception e5)
    {
      System.out.println("");
      System.out.println("Fatal Error: Can't close file(s)!");
      System.exit(1);
    }

    System.out.println("");
    System.out.println("Program finished sucessfully!");

    System.exit(0);
  }

  //*************************************************************************
  public static String tab2space_f77(String str)
  {
    int i;
    String str1="";

    if (str!=null)
    {
      int len=str.length();
      if (len!=0)
      {
        for (i=0; i<len; i++)
        {
          char c=str.charAt(i);
          int num=c;
          num&=255;
          if (num==9)
          {
            str1+="      ";
          }
          else
          {
            str1+=String.valueOf(c);
          }
        }
      }
    }

    return str1;
  }

}
