/*
 * MPC Feedback Module 2 for ATOM (instrumentation)
 *
 * Copyright (C) 2000-2004 by Grigori G. Fursin
 *
 * homepage: http://homepages.inf.ed.ac.uk/gfursin
 *
 * ICSA, School of Informatics,
 * University of Edinburgh, UK
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <machine/inst.h>
#include <cmplrs/atom.inst.h>

void InstrumentInit(int p1, char **p2) 
{
  AddCallProto("MPCInit(int)");
  AddCallProto("MPCProcCount(int, int)");
  AddCallProto("MPCFinish()");
}

void fggstrlwr(char* addr)
{
  char c;

  while ((c=*addr)!=0)
  {
    *addr=tolower(c);
    addr++;
  }
}

Instrument(int argc, char **argv, Obj *obj)
{
  Proc *p;  
  Block *b; 

  FILE *fmpc1;

  char procname[1024];
  char procname1[1024];

  int ret=0;

  int proc=0;

  /*************************** Main ***************************/
  printf("EOS MPC Feedback Module 2   (C) by Grigori G. Fursin   August,2001\n");

  if ((fmpc1=fopen("_eos_mpc_fb2.dat","rt"))==NULL)
  {
    fprintf(stderr, "\nFatal Error: Can't find file with parameters!\n");
    exit(1);
  }

  do
  {
    if ((ret=fscanf(fmpc1, "%s", &procname[0]))!=EOF)
    {
      fggstrlwr(procname);

      printf("\nSearching subroutine: %s\n", procname);

      for (p=GetFirstObjProc(obj); p!=NULL; p=GetNextProc(p))
      {
        if (ProcName(p)!=NULL) strcpy(procname1, ProcName(p));
        else strcpy(procname1, "");

        fggstrlwr(procname1);

        if (strcmp(procname1, procname)==0)
        {   
          printf("Subroutine %s found!\n", procname);


          for (b=GetFirstBlock(p); b!=NULL; b=GetNextBlock(b))
          {
            if (b==GetFirstBlock(p)) b=GetNextBlock(b);
            AddCallBlock(b, BlockBefore, "MPCProcCount",
                         proc, GetBlockInfo(b, BlockNumberInsts));
          }
        }
      }  

      proc++;
    }
  } while (ret!=EOF);

  /************************************************************/
  printf("\nEbedding additional code ...\n");

  AddCallProgram(ProgramBefore,"MPCInit", proc);
  AddCallProgram(ProgramAfter, "MPCFinish");

  printf("\nInstrumentation finished!\n");

  fclose(fmpc1);
}
